import greenlet
import stackliss

def Receiver(channel):
    print "Receiver (before)"
    value = channel.receive()
    print "Received:", value
    

def Sender(channel):
    print "Sender (before)"
    channel.send("hello")
    print "Sender (after)"

def Threebie():
    for i in xrange(3):
        stackliss.scheduler.Yield()

if __name__ == "__main__":
    print "***** Sender / Receiver"

    channel = stackliss.channel()
    stackliss.tasklet(Sender)(channel).name = "Sender"
    stackliss.tasklet(Receiver)(channel).name = "Receiver"
    stackliss.tasklet(Threebie)().name = "Threebie"

    while stackliss.runcount:
        t = stackliss.run(0)
        if t:
            print "Timed out tasklet", t

    print "***** Receiver / Sender"

    channel = stackliss.channel()
    stackliss.tasklet(Receiver)(channel).name = "Receiver"
    stackliss.tasklet(Sender)(channel).name = "Sender"

    while stackliss.runcount:
        t = stackliss.run(0)
        if t:
            print "Timed out tasklet", t
